﻿
{
   var myPanel;

   function interlaced_view_buildUI(thisObj) {
      myPanel = (thisObj instanceof Panel) ? thisObj : new Window("palette", "Interlaced View", [100, 100, 300, 300]);

      //Jeff Almasol's solution to fix text color
      var winGfx = myPanel.graphics;
      var darkColorBrush = winGfx.newPen(winGfx.BrushType.SOLID_COLOR, [0,0,0], 1);

      //notes------------------------------------[10, 10, 40, 30] = [LeftEdge, TopEdge, ButtonEdge, ButonEdge]
      //"Qty:" text
      myPanel.butOne = myPanel.add("staticText", [10, 10, 150, 30], "Generate interlaced comp");
	  
	  myPanel.butRoto = myPanel.add("checkbox", [10, 30, 80, 50], "Roto mode");
	  myPanel.butRoto.value = 1;
	  myPanel.butRF = myPanel.add("checkbox", [90, 30, 200, 50], "Swap Fields order");

      //Input box
      //myPanel.butTwo = myPanel.add("editText", [200, 10, 230, 30], "5");
      //myPanel.butTwo.graphics.foregroundColor = darkColorBrush;   //Keeps text black at all times

      //"Do It!" button
      myPanel.butThree = myPanel.add("button", [10, 60, 100, 80], "Do It!");
      myPanel.butThree.onClick = Make_fields_view;   //launch "dupIt" function when button is clicked
	  
	  

      return myPanel;
   }

   function Make_fields_view() {
	app.beginUndoGroup("Fields view");   
	if(myPanel.butRF.value == 1)
		{
			var reverse_fields_order =0;   // 0 or 1 for reverse field order
		}
	else
		{
			var reverse_fields_order =1;   // 0 or 1 for reverse field order
		}

	if ((app.project.activeItem == null) || ((app.project.activeItem != null) && !(app.project.activeItem instanceof CompItem)))
		{
			alert("Select one Composition to see fields !!");	
		}
	else
		{
		var comp = app.project.activeItem;
		var myItemCollection = app.project.items; 
		var myComp_field_view = myItemCollection.addComp(comp.name+" Interlaced view", comp.width, comp.height,comp.pixelAspect, comp.duration, comp.frameRate); // create comp interlaced or single field
		var comp_bg = myComp_field_view.layers.add(comp); //add original comp in fields view 
		var Fields_viewer_1 = myComp_field_view.layers.addSolid([.5,.5,.5], "Fields Viewer", comp.width,comp.height,comp.pixelAspect,comp.duration); // add solid in  fields view comp
		var comp_layer = myComp_field_view.layers.add(comp); //add original comp in fields view
		var Fields_viewer_2 = myComp_field_view.layers.addSolid([.5,.5,.5], "Fields Viewer", comp.width,comp.height,comp.pixelAspect,comp.duration); // add solid in  fields view comp
		comp_layer.startTime=-1/(comp.frameRate*2); 
		comp_layer.trackMatteType=TrackMatteType.ALPHA;
		comp_bg.trackMatteType=TrackMatteType.ALPHA_INVERTED;
		Fields_viewer_2.Effects.addProperty("Grid"); // add grid
		myComp_field_view.layer(1).property("Effects").property(1).property("Size From").setValue(3);
		myComp_field_view.layer(1).property("Effects").property(1).property("Width").setValue(myComp_field_view.width*myComp_field_view.pixelAspect+20);
		myComp_field_view.layer(1).property("Effects").property(1).property("Height").setValue(2);
		myComp_field_view.layer(1).property("Effects").property(1).property("Anchor").setValue([-2,reverse_fields_order]);
		myComp_field_view.layer(1).property("Effects").property(1).property("Border").setValue(1);
		myComp_field_view.layer(1).Effects.addProperty("Levels (Individual Controls)"); 
		myComp_field_view.layer(1).property("Effects").property(2).property("Alpha Input White").setValue(125/255);
		Fields_viewer_1.Effects.addProperty("Grid"); // add grid
		myComp_field_view.layer(3).property("Effects").property(1).property("Size From").setValue(3);
		myComp_field_view.layer(3).property("Effects").property(1).property("Width").setValue(myComp_field_view.width*myComp_field_view.pixelAspect+20);
		myComp_field_view.layer(3).property("Effects").property(1).property("Height").setValue(2);
		myComp_field_view.layer(3).property("Effects").property(1).property("Anchor").setValue([-2,reverse_fields_order]);
		myComp_field_view.layer(3).property("Effects").property(1).property("Border").setValue(1);
		myComp_field_view.layer(3).Effects.addProperty("Levels (Individual Controls)"); 
		myComp_field_view.layer(3).property("Effects").property(2).property("Alpha Input White").setValue(125/255);
		Fields_viewer_1.locked= true; //lock fields view
		Fields_viewer_2.locked= true; //lock fields view
		comp_layer.locked= true; //lock comp layer
		comp_bg.locked= true; //lock comp bg
			if (myPanel.butRoto.value == 1)
			{
				comp.name=comp.name+" Field by field"; // rename original comp 
				comp.frameRate=comp.frameRate*2;// double original frame rate for field by field view 
			}
		
		app.endUndoGroup();
		}	   

   }

   interlaced_view_buildUI(this);
}